## mingw-w64-waf-2.1.9-1.src.tar.zst

=== demos/qt6/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2016 (ita)
# Federico Pellegrin, 2019 (fedepell)
# Rafaël Kooi, 2024 (RA-Kooi)

VERSION='0.0.1'
APPNAME='qt6_test'

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_cxx qt5 waf_unit_test')

def configure(conf):
	conf.want_qt6 = True

	# set a mandatory list of libraries for the detection
	#conf.qt6_vars = ['Qt6Core', 'Qt6Gui', 'Qt6Widgets', 'Qt6Test', 'Qt6Svg']

	conf.load('compiler_cxx qt5 waf_unit_test')
	#conf.env.append_value('CXXFLAGS', ['-g']) # test

	if not conf.env.QT_LRELEASE:
		# While Qt6 detects most Qt tools, most of them are optional
		conf.fatal('lrelease was not found')

	conf.check(
		define_name  = 'XYZ_QT6_TESTS',
		mandatory    = False,
		execute      = True,
		features     = 'qt6 cxx cxxprogram',
		includes     = '.',
		defines      = 'QT_WIDGETS_LIB',
		use          = 'QT6CORE QT6GUI QT6WIDGETS QT6TEST',
		msg          = 'Checking whether Qt6 tests can run',
		fragment     = '''
#include <QtTest/QtTest>
class TestQt6Test: public QObject {
	Q_OBJECT
private:
	void testGui() {
		QWidget *widget = NULL;
		QTest::mouseClick(widget, Qt::LeftButton, Qt::NoModifier, QPoint(5,5), 0);
	}
};

QTEST_MAIN(TestQt6Test)
#include "test.moc"
''')

def build(bld):
	# According to the Qt6 documentation:
	#   Qt classes in foo.h   -> declare foo.h as a header to be processed by moc
	#			    add the resulting moc_foo.cpp to the source files
	#   Qt classes in foo.cpp -> include foo.moc at the end of foo.cpp
	#
	bld(
		features = 'qt6 cxx cxxprogram',
		use      = 'QT6CORE QT6GUI QT6SVG QT6WIDGETS',
		source   = 'main.cpp res.qrc but.ui foo.cpp',
		moc      = 'foo.h',
		target   = 'window',
		includes = '.',
		lang     = bld.path.ant_glob('linguist/*.ts'),
		langname = 'somefile', # include the .qm files from somefile.qrc
	)

	if bld.env.XYZ_QT6_TESTS:
		# Example of integration of Qt6 Unit tests using Qt6Test using waf_unit_test
		bld(
			features = 'qt6 cxx cxxprogram test',
			use      = 'QT6CORE QT6GUI QT6WIDGETS QT6TEST',
			defines  = 'QT_WIDGETS_LIB',
			source   = 'foo.cpp testqt6.cpp',
			moc      = 'foo.h',
			target   = 'footest',
			includes = '.',
			# ut_str   = './${SRC} -o test-report.xml,xunitxml', # put output to a xunit xml
		)

		bld.add_post_fun(print_test_results)	# print output of test runner to user


def print_test_results(bld):
	lst = getattr(bld, 'utest_results', [])
	if not lst:
		return
	for result in lst:
		print(result.out.decode('utf-8'))
		print(result.err.decode('utf-8'))

=== demos/ruby/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Frauendorfer, 2010

VERSION='0.0.1'
APPNAME='ruby_test'

# these variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_c')
	opt.load('ruby')

def configure(conf):
	conf.load('compiler_c')
	conf.load('ruby')

	# check for ruby
	conf.check_ruby_version((1,8,0))
	conf.check_ruby_ext_devel()
	conf.check_ruby_module('libxml', mandatory=False)

def build(bld):

	# Build a ruby extension module
	bld(
		features = 'c cshlib rubyext',
		source = 'rb_mytest.c',
		target = 'mytest_ext',
		install_path = '${ARCHDIR_RUBY}')

	bld.install_files('${LIBDIR_RUBY}', 'Mytest.rb')

	if bld.cmd == 'runit':
		def foo(bld):
			bld.exec_command(bld.env.RUBY + ' -I' + bld.get_variant_dir() + ' -rMytest -e "Mytest.hello()"')
		bld.add_post_fun(foo)

	# or, another way
	bld(source='hello_world.rb')

from waflib.Build import BuildContext
class one(BuildContext):
	cmd = 'runit'

=== demos/tex/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2005-2015 (ita)

VERSION='1.0.0'
APPNAME='tex_test'

top = '.'
out = 'build'

def configure(conf):
	conf.load('tex')
	if not conf.env.PDFLATEX:
		conf.fatal('could not find the program pdflatex')
	if not conf.env.MAKEGLOSSARIES:
		conf.fatal('could not find the program makeglossaries which is absolutely required for this example')


	# and example of a complex configuration test
	def build_latex_test(bld):
		def write_tex(tsk):
			tsk.outputs[0].write(r'''\documentclass[a4paper,12pt]{article}  \usepackage{ucs}  \begin{document} test \end{document} ''')
		bld(rule=write_tex, target='main.tex')
		bld(features='tex', type='pdflatex', source='main.tex', prompt=0)
	conf.test(build_fun=build_latex_test, msg='Checking for UCS', okmsg='ok', errmsg='ucs.sty is missing install latex-extras')

def build(bld):
	bld.recurse('src')

=== demos/variants/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2010 (ita)

VERSION='0.0.1'
APPNAME='cc_test'

top = '.'
out = 'build'

"""
General variant system

Call for example:
$ waf configure build_debug build_release clean_debug clean_release

The builds will end in different build folders
note how "bld.variant" is used to detect the current variant

See also playground/remote/wscript for a more specific example
"""

def configure(conf):

	conf.setenv('debug')
	conf.load('compiler_c')
	conf.define("A", 1)
	conf.define("B", 1.1)
	conf.define("C", "1.1e19", quote=False)
	# the configuration file must be written in each variant
	conf.write_config_header('debug/config.h', remove=False)

	conf.setenv('release', env=conf.env.derive()) # start with a copy instead of a new env
	conf.env.CFLAGS = ['-O2']
	conf.options.prefix = '/opt' # warning: this changes the options globally
	conf.load('compiler_c')
	conf.define('E', 1)
	conf.write_config_header('release/config.h')

def build(bld):

	# cleaning from the top-level directory might remove
	# the file 'config.h' from the variants, so we
	# are forcing the use of *debug or *release commands
	#
	# the config set 'debug' is loaded automatically when the 'debug' variant is used
	if not bld.variant:
		bld.fatal('Call "waf build_debug" or "waf build_release" (same with "clean_debug") and read the comments in the wscript file!')

	# the includes='.' add the build directory path to the command arguments
	# (look at the -I flags by using waf -v)
	bld.program(source='main.c', target='app', includes='.')

	# To use multiple compilers at once, either:
	#
	# * use a particular environment from the configuration:
	#     bld.env = bld.all_envs['debug']
	#     bld.program(source='main.c', target='app2', includes='.')
	# * add an 'env' parameter to a particular task generator:
	#     bld.program(...,  env=bld.all_envs['release'].derive())

def options(opt):
	opt.load('compiler_c')

def init(ctx):
	from waflib.Build import BuildContext, CleanContext, InstallContext, UninstallContext

	for x in 'debug release'.split():
		for y in (BuildContext, CleanContext, InstallContext, UninstallContext):
			name = y.__name__.replace('Context','').lower()
			class tmp(y):
				cmd = name + '_' + x
				variant = x

	## if you work on "debug" 99% of the time, here is how to re-enable "waf build":
	#for y in (BuildContext, CleanContext, InstallContext, UninstallContext):
	#	class tmp(y):
	#		variant = 'debug'
	# you may also set 'win32/debug' instead of 'debug'
	# the commands will be "build_win32/debug" or "build_win32/release"
	# in this case you may want to modify Options.commands in this "init" function

# calling "waf buildall" will run "waf build_debug build_release"
def buildall(ctx):
	import waflib.Options
	for x in ('build_debug', 'build_release'):
		waflib.Options.commands.insert(0, x)

# --------------------------
# or, if you want to memorize the default variant and just type "waf",
#
#def options(opt):
#	opt.load('compiler_c')
#def init(ctx):
#	from waflib import ConfigSet, Options
#	env = ConfigSet.ConfigSet()
#	try:
#		env.load('build/c4che/foo.txt')
#	except:
#		the_variant = 'debug'
#	else:
#		the_variant = env.the_variant or debug
#
#	if getattr(Options.options, 'the_variant', ''):
#		if Options.options.the_variant != the_variant:
#			the_variant = env.the_variant = Options.options.the_variant
#			env.store('build/c4che/foo.txt')
#
#	for y in (BuildContext, CleanContext, InstallContext, UninstallContext):
#		class tmp(y):
#			variant = the_variant
# --------------------------
# Or, if you like to have a command-line flag
#   - add ctx.load('variant') to options and init functions
#   - add --variant=<name of the variant> to the command line
#def options(ctx):
#    ctx.add_option('--variant', action='store', default='', help='set the variant name')
#def init(ctx):
#    from waflib.Options import options
#    from waflib.Build import BuildContext, CleanContext, InstallContext, UninstallContext
#    from waflib.Configure import ConfigurationContext
#    for y in (BuildContext, CleanContext, InstallContext, UninstallContext, ConfigurationContext):
#        name = y.__name__.replace('Context','').lower()
#        class tmp(y):
#            cmd = name
#            variant = options.variant
#

=== docs/sphinx/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = build

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help clean html dirhtml singlehtml pickle json htmlhelp qthelp devhelp epub latex latexpdf text man changes linkcheck doctest

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*

html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/waf.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/waf.qhc"

devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/waf"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/waf"
	@echo "# devhelp"

epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

=== playground/compress/wscript ===
#! /usr/bin/env python

"""
You will need either bzip2 or gzip, and a local waf copy
(unset the variable WAFDIR if set)

Using more than 100000 tasks may eat your memory
"""

top = '.'
out = 'build'

TEMPLATE = """
#! /usr/bin/gnuplot -persist
# output file, compression type, input file
set terminal png
set output "%s"
set ylabel "Amount of files created"
set xlabel "File size in kB"
set title "Compressed tar file distribution (%s)"
plot '%s' using 1:2 with lines lt 3 title ""
"""

import random, bz2, os, threading
lock = threading.Lock()

def options(opt):
	opt.add_option('--num', action='store', type=int, default=200, help='amount of compressed files to create')

# values for storing the min and max
gzip  = [10000000, 0]
bzip2 = [10000000, 0]
xz    = [10000000, 0]

def try_compress(self):
	global mi, ma

	frompath = self.generator.frompath

	uid = id(threading.current_thread())
	filename = frompath.abspath() + os.sep + 'test%d.bin' % uid

	self.files = self.generator.files[:]
	random.shuffle(self.files)

	if self.generator.kind == 'bzip2':
		store = bzip2
		cmd = 'cjf'
		ext = 'bz2'
	elif self.generator.kind == 'xz':
		store = xz
		cmd = 'cJf'
		ext = 'xz'
	else:
		store = gzip
		cmd = 'czf'
		ext = 'gz'

	self.generator.bld.exec_command('tar %s  %s  %s' % (cmd, filename, ' '.join(self.files)), cwd=frompath.abspath())

	siz = os.stat(filename).st_size
	if siz == 0:
		return -1

	try:
		lock.acquire()
		self.outputs[0].write('%d\n' % siz, 'a')

		if siz < store[0]:
			store[0] = siz
			os.rename(filename, self.generator.bld.bldnode.abspath() + os.sep + 'min%d.tar.%s' % (siz, ext))
		elif siz > store[1]:
			store[1] = siz
			os.rename(filename, self.generator.bld.bldnode.abspath() + os.sep + 'max%d.tar.%s' % (siz, ext))
		else:
			os.remove(filename)
	finally:
		lock.release()

def count_result(self):
	txt = self.inputs[0].read().strip()
	lst = txt.split()
	lst = [int(x) for x in lst if x]
	mi = min(lst)
	ma = max(lst)

	dc = {}
	for x in lst:
		try:
			dc[x] += 1
		except KeyError:
			dc[x] = 1

	nlst = ['%d %d' % (x, dc.get(x, 0)) for x in range(mi, ma+1)]
	self.outputs[0].write('\n'.join(nlst))

def write_template(self):
	t = self.generator.triplet
	self.outputs[0].write(TEMPLATE % (t[0].abspath(), t[1], t[2].abspath()))

def configure(conf):
	conf.find_program('gzip', mandatory=False)
	conf.find_program('bzip2', mandatory=False)
	if not conf.env.GZIP and not conf.env.BZIP2:
		conf.fatal('Either gzip or bzip2 is necessary for this')

	# xz is a gzip-like, lzma-based compression tool
	conf.find_program('xz', mandatory=False)

	conf.find_program('gnuplot', var='GNUPLOT')

def build(bld):
	wafdir_lst = bld.srcnode.ant_glob('.waf*', dir=True)
	if not wafdir_lst:
		bld.fatal('Missing local Waf directory')
	node = wafdir_lst[0]
	rels = [x.path_from(node) for x in node.ant_glob('**/*.py')]

	KINDS = []
	if bld.env.BZIP2:
		KINDS.append('bzip2')
	if bld.env.GZIP:
		KINDS.append('gzip')
	if bld.env.XZ:
		KINDS.append('xz')

	for kind in KINDS:
		p = bld.bldnode

		ini  = p.make_node('size_%s_1.txt' % kind)  # list of file sizes
		dist = p.make_node('size_%s_2.txt' % kind)  # distribution file (count the results)
		plot = p.make_node('size_%s_3.plot' % kind) # script file created for gnuplot
		png  = p.make_node('size_%s_4.png' % kind)  # picture created

		for x in range(bld.options.num):
			# the same target cannot have the signature of all the tasks that update it
			# so the tasks will be executed each time
			bld(rule=try_compress, target=ini, always=True, kind=kind, frompath=node, files=rels)

		# for the same reason, count_result will be executed each time
		bld(rule=count_result, target=dist, source=[ini], always=True)
		bld(rule=write_template, target=plot, triplet=[png, kind, dist], always=True)
		bld(rule='${GNUPLOT} < ${SRC[1].abspath()}', target=png, source=[dist, plot])

=== playground/doxy/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2008-2012 (ita)

from waflib import Build, TaskGen

VERSION='0.0.1'
APPNAME='cc_test'

top = '.'
out = 'build'

def options(opt):
	opt.load('compiler_cxx')

def configure(conf):
	conf.load('compiler_cxx doxygen')
	if not conf.env.DOXYGEN:
		conf.fatal('doxygen is required, install it')

# NOTES:
#
# 1. The test.conf file has "OUTPUT_DIRECTORY" commented
#
# 2. Doxygen parameters may be passed using pars attribute
#       e.g. pars={'EXCLUDE_PATTERNS': '*.foo'}
#
# 3. if you want to build the docs in another command, use something like:
#    if bld.cmd == 'doxy': in the build
#

def build(bld):
	# if the documentation is to packed, simply set doxy_tar to the filename
	bld(
		features='doxygen',
		doxyfile='test.conf',
		install_path='${PREFIX}/doc')

	# and additional targets
	bld(features='cxx cxxshlib', source='subdir/c.cpp', target='somelib')

# example for the NOTES point #3
from waflib import Build
class doxy(Build.BuildContext):
	fun = 'build'
	cmd = 'doxy'

=== playground/exclusive_link/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2011 (ita)

VERSION='0.0.1'
APPNAME='cc_test'

top = '.'

def options(opt):
	opt.load('compiler_c')

def configure(conf):
	conf.load('compiler_c')
	conf.load('excl', tooldir='.')

def build(bld):
	for i in range(20):
		bld.program(source='main.c', target='app_%d' % i)

=== playground/gdbus/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Copyright Garmin International or its subsidiaries, 2018

VERSION = '1.0'

def options(opt):
	opt.load('compiler_c')

def configure(conf):
	conf.load('compiler_c gdbus')
	conf.check_cfg(package='gio-2.0', args='--cflags --libs')
	conf.check_cfg(package='gio-unix-2.0', args='--cflags --libs')
	conf.check_cfg(package='glib-2.0', args='--cflags --libs')

def build(bld):
	tg = bld.program(
		includes = '.',
		source = bld.path.ant_glob('*.c'),
		target = 'gnome-hello',
		use = 'GIO-2.0 GIO-UNIX-2.0 GLIB-2.0')

	tg.add_gdbus_file('test.xml', 'test_prefix', 'glib_server')

=== playground/gtest/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Sylvain Rouquette, 2014
# based on Richard Quirk's demo (unit_test), 2008

"""
Execute tests during the build - requires cppunit

To force all tests, run with "waf build --alltests"
"""

from waflib import Logs

top = '.'
out = 'build'

def options(opt):
    opt.load('compiler_cxx')
    opt.load('waf_unit_test')
    opt.add_option('--onlytests', action='store_true', default=True, help='Exec unit tests only', dest='only_tests')

def configure(conf):
    conf.load('compiler_cxx')
    conf.load('waf_unit_test')
    conf.check(lib='gtest', uselib_store='GTEST')


def gtest_results(bld):
    lst = getattr(bld, 'utest_results', [])
    if not lst:
        return
    for result in lst:
        # if not result.exit_code:
        #     continue

        # uncomment if you want to see what's happening
        # print(str(out, 'utf-8'))
        output = str(result.out, 'utf-8').splitlines()
        for i, line in enumerate(output):
            if '[ RUN      ]' in line and result.exit_code:
                i += 1
                if '    OK ]' in output[i]:
                    continue
                while not '[ ' in output[i]:
                    Logs.warn(output[i])
                    i += 1
            elif ' FAILED  ]' in line and result.exit_code:
                Logs.error(line)
            elif ' PASSED  ]' in line:
                Logs.info(line)

def build(bld):
    bld.recurse('src tests')

    # waf_unit_test.summary is a pretty ugly function for displaying a report (feel free to improve!)
    # results -> bld.utest_results [(filename, returncode, stdout, stderr), (..., ), ...]
    #bld.add_post_fun(waf_unit_test.summary)
    bld.add_post_fun(gtest_results)

    # to execute all tests:
    # $ waf --alltests
    # to set this behaviour permanently:
    bld.options.all_tests = True

    # debugging zone:
    # $ waf --zones=ut
    # setting the cwd for a unit test execution: see tests/test1/wscript_build (ut_cwd)

=== playground/javatest/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Federico Pellegrin, 2019 (fedepell)

#
# Simple script to demonstrate integration of Java Unit testing inside
# standard waf_unit_test using either TestNG or JUnit
#
# try:
#   waf configure --jtpath=/usr/share/java/testng.jar:/usr/share/java/jcommander.jar clean build

def test_results(bld):
	"""
	Custom post- function that prints out test results.
	"""
	lst = getattr(bld, 'utest_results', [])
	if not lst:
		return
	for result in lst:
		print(result.out.decode('utf-8'))
		print(result.err.decode('utf-8'))


def options(opt):
	opt.load('java waf_unit_test javatest')
	opt.load('compiler_c')

def configure(conf):
	conf.load('java javatest')
	conf.load('compiler_c')
	conf.check_jni_headers()

def build(bld):
	bld(features = 'javac',
		name = 'mainprog',
		srcdir     = 'src/', # folder containing the sources to compile
		outdir     = 'src', # folder where to output the classes (in the build directory)
		sourcepath = ['src'],
		basedir    = 'src', # folder containing the classes and other files to package (must match outdir)
	)


	bld(features = 'javac javatest',
		srcdir     = 'test/', # folder containing the sources to compile
		outdir     = 'test', # folder where to output the classes (in the build directory)
		sourcepath = ['test'],
		classpath  = [ 'src' ],
		basedir    = 'test', # folder containing the classes and other files to package (must match outdir)
		use = ['JAVATEST', 'mainprog'],
		ut_str = 'java -cp ${CLASSPATH} ${JTRUNNER} ${SRC}',
		jtest_source = bld.path.ant_glob('test/*.xml'),
		# For JUnit do first JUnit configuration and no need to use jtest_source:
		# ut_str = 'java -cp ${CLASSPATH} ${JTRUNNER} [TestClass]',
	)


	# Demonstrate correct handling also of dependency to non-java tasks (see !2257)
	bld(name='stjni', features='javac jar', srcdir='jni/java', outdir='jni/java', basedir='jni/java', destfile='stringUtils.jar')

	bld.shlib(source   = 'jni/jni/source/StringUtils.c',
		includes = 'jni/jni/include',
		target   = 'jni/stringUtils',
		uselib   = 'JAVA')

	bld(features = 'javac javatest',
		srcdir     = 'jni/test/', # folder containing the sources to compile
		outdir     = 'jni/test', # folder where to output the classes (in the build directory)
		sourcepath = ['jni/test'],
		classpath  = [ 'jni/src' ],
		basedir    = 'jni/test', # folder containing the classes and other files to package (must match outdir)
		use = ['JAVATEST', 'stjni', 'jni/stringUtils'],
		ut_str = 'java -cp ${CLASSPATH} ${JTRUNNER} ${SRC}',
		jtest_source = bld.path.ant_glob('jni/test/*.xml'),
	)


	bld.add_post_fun(test_results)

=== playground/ldscript/wscript ===
#! /usr/bin/env python
# encoding: utf-8
# Thomas Nagy, 2009 (ita)

VERSION='0.0.1'
APPNAME='cc_test'

top = '.'
out = 'build'

def configure(conf):
	conf.load('gcc')

def build(bld):

	bld.program(
		source    = 'main.c',
		target    = 'test',
		ldscript  = 'myscript.ld',
		linkflags = ['-nostdlib'],
		)

from waflib import Errors
from waflib.TaskGen import after_method, feature

@after_method('propagate_uselib_vars')
@feature('cprogram', 'cshlib')
def process_ldscript(self):
	if not getattr(self, 'ldscript', None) or self.env.CC_NAME != 'gcc':
		return

	node = self.path.find_resource(self.ldscript)
	if not node:
		raise Errors.WafError('could not find %r' % self.ldscript)
	self.link_task.env.append_value('LINKFLAGS', '-Wl,-T,%s' % node.abspath())
	self.link_task.dep_nodes.append(node)

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=waf
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=2.1.9
pkgrel=1
pkgdesc="General-purpose build system modelled after Scons (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://waf.io/"
msys2_repository_url="https://gitlab.com/ita1024/waf"
msys2_changelog_url='https://gitlab.com/ita1024/waf/-/blob/master/ChangeLog'
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-python")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc")
options=('!emptydirs')
source=("https://waf.io/${_realname}-${pkgver}.tar.bz2"{,.asc})
validpgpkeys=('8AF22DE5A06822E3474F3C7049B4C67C05277AAA'
              '0B3972B2D9E32EAB423D2E0F22BE0C62FFBFA548'  # "Thomas Nagy <tnagy@waf.io>"
              '8C7EB2F93B0C45F5732FE5D11BAC571DCD772295') # Waf Project <noreply@waf.io>
sha256sums=('4a47a431b86d5c42fa23b8474aaf752384dcaed65fe9e6aa1f518c103d38a7d1'
            'SKIP')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"

  # Extract license
  head -n 30 waf-light | tail -n 25 > LICENSE
}

build() {
  cd "${srcdir}/${_realname}-${pkgver}"
  plain "Configure ..."
  ${MINGW_PREFIX}/bin/python ./waf-light configure --prefix=${MINGW_PREFIX}
  plain "Make waf ..."
  ${MINGW_PREFIX}/bin/python ./waf-light --make-waf
}

package() {
  cd "${srcdir}/${_realname}-${pkgver}"

  prelude=$(cat <<'EOF'
	import waflib.Tools.compiler_c, waflib.Tools.compiler_cxx
	waflib.Tools.compiler_c.c_compiler['win32'] = ['gcc', 'clang', 'msvc']
	waflib.Tools.compiler_cxx.cxx_compiler['win32'] = ['g++', 'clang++', 'msvc']
EOF
  )

  ${MINGW_PREFIX}/bin/python ./waf-light install -f --destdir="${pkgdir}" \
    --prelude="${prelude}" \
    --tools='compat,compat15,ocaml,go,cython,scala,erlang,cuda,gcj,boost,pep8,eclipse,unity,clang_compilation_database'

  install -Dm755 waf "${pkgdir}${MINGW_PREFIX}/bin/waf"
  install -Dm755 waf.bat "${pkgdir}${MINGW_PREFIX}/bin/waf.bat"

  # Force the generation of .waf.admin files
  cd "${srcdir}/${_realname}-${pkgver}/demos/c"
  CC_NAME=${CC} CC="${MINGW_PREFIX}/bin/${CC}.exe" \
  CXX_NAME=${CXX} CXX="${MINGW_PREFIX}/bin/${CXX}.exe" \
  "${pkgdir}${MINGW_PREFIX}/bin/waf" configure build

  # Fix weird directory placement (FS#38216, FS#38300)
  mkdir -p "${pkgdir}${MINGW_PREFIX}/lib/waf"
  mv "${pkgdir}${MINGW_PREFIX}/bin/waf3-${pkgver}-"* "${pkgdir}${MINGW_PREFIX}/lib/waf/"
  sed -s "s|INSTALL=''|INSTALL='${MINGW_PREFIX}/lib/waf'|g" -i "${pkgdir}${MINGW_PREFIX}/bin/waf"

  cd "${srcdir}/${_realname}-${pkgver}"
  install -Dm644 LICENSE "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
